// C Source File
// Created 2/25/2005; 10:54:43 PM
// I (RANDY ROZ) took the Malbolge source & modified it so it would run on a TI-89/92+.
// I hearby release my modifications into the public domain.
#define USE_TI89
#define USE_TI92PLUS
#define MIN_AMS 101
#define SAVE_SCREEN
#include <tigcclib.h>

/* Interpreter for Malbolge.                                          */
/* '98 Ben Olmstead.                                                  */
/*                                                                    */
/* Malbolge is the name of Dante's Eighth circle of Hell.  This       */
/* interpreter isn't even Copylefted; I hereby place it in the public */
/* domain.  Have fun...                                               */
/*                                                                    */
/* Note: in keeping with the idea that programming in Malbolge is     */
/* meant to be hell, there is no debugger.                            */
/*                                                                    */
/* By the way, this code assumes that short is 16 bits.  I haven't    */
/* seen any case where it isn't, but it might happen.  If short is    */
/* longer than 16 bits, it will still work, though it will take up    */
/* considerably more memory.                                          */
/*                                                                    */
/* If you are compiling with a 16-bit Intel compiler, you will need   */
/* >64K data arrays; this means using the HUGE memory model on most   */
/* compilers, but MS C, as of 8.00, possibly earlier as well, allows  */
/* you to specify a custom memory-model; the best model to choose in  */
/* this case is /Ashd (near code, huge data), I think.                */
static inline void exec( unsigned short *mem );
static inline unsigned short op( unsigned short x, unsigned short y );
const char xlat1[] =
  "+b(29e*j1VMEKLyC})8&m#~W>qxdRp0wkrUo[D7,XTcA\"lI"
  ".v%{gJh4G\\-=O@5`_3i<?Z';FNQuY]szf$!BS/|t:Pn6^Ha";
const char xlat2[] =
  "5z]&gqtyfr$(we4{WP)H-Zn,[%\\3dL+Q;>U!pJS72FhOA1C"
  "B6v^=I_0/8|jsb9m<.TVac`uY*MK'X~xDl}REokN:#?G\"i@";
void _main()
{
  FILE *f;
  unsigned short i = 0;
  int x;
  unsigned short *mem;
  ESI ap=top_estack;
  if ( GetArgType(ap) != STR_TAG )
  {
    DlgMessage( "Malbolge", "invalid command line\n", BT_OK, BT_NONE );
    return;
  }
  if ( ( f = fopen( GetStrnArg(ap), "r" ) ) == NULL )
  {
    DlgMessage( "Malbolge", "can't open file\n", BT_OK, BT_NONE );
    return;
  }
  mem = (unsigned short *)malloc( sizeof(unsigned short) * 19683 );
  if ( mem == NULL )
  {
    fclose( f );
    DlgMessage( "Malbolge", "can't allocate memory\n", BT_OK, BT_NONE );
    return;
  }
  while ( ( x = getc( f ) ) != EOF )
  {
    if ( isspace( x ) ) continue;
    if ( x < 127 && x > 32 )
    {
      if ( strchr( "ji*p</vo", xlat1[( x - 33 + i ) % 94] ) == NULL )
      {
        free( mem );
        fclose( f );
        DlgMessage( "Malbolge", "invalid character in source file\n", BT_OK, BT_NONE );
        return;
      }
    }
    if ( i == 19683 )
    {
      free( mem );
      fclose( f );
      DlgMessage( "Malbolge", "input file too long\n", BT_OK, BT_NONE );
      return;
    }
    mem[i++] = x;
  }
  fclose( f );
  while ( i < 19683 ) mem[i] = op( mem[i - 1], mem[i - 2] ), i++;
  exec( mem );
  free( mem );
  getchar();
  return;
}
static inline void exec( unsigned short *mem )
{
  unsigned short a = 0, c = 0, d = 0;
  int x;
  for (;;)
  {
    if(_keytest(RR_APPS)){ST_helpMsg("Break pressed.");return;}
    if ( mem[c] < 33 || mem[c] > 126 ) continue;
    switch ( xlat1[( mem[c] - 33 + c ) % 94] )
    {
      case 'j': d = mem[d]; break;
      case 'i': c = mem[d]; break;
      case '*': a = mem[d] = mem[d] / 3 + mem[d] % 3 * 19683; break;
      case 'p': a = mem[d] = op( a, mem[d] ); break;
      case '<':
        putchar( a );
        break;
      case '/':
        x = getchar(  );
        if ( x == EOF ) a = 59048; else a = x;
        break;
      case 'v': ST_helpMsg("Program terminated normally."); return;
    }
    mem[c] = xlat2[mem[c] - 33];
    if ( c > 19682 ){ST_helpMsg("Code pointer out of bounds.");return;}else c++;
    if ( d > 19682 ){ST_helpMsg("Data pointer out of bounds.");return;}else d++;
  }
}
static inline unsigned short op( unsigned short x, unsigned short y )
{
  unsigned short i = 0, j;
  static const unsigned short p9[5] =
    { 1, 9, 81, 729, 6561 };
  static const unsigned short o[9][9] =
    {
      { 4, 3, 3, 1, 0, 0, 1, 0, 0 },
      { 4, 3, 5, 1, 0, 2, 1, 0, 2 },
      { 5, 5, 4, 2, 2, 1, 2, 2, 1 },
      { 4, 3, 3, 1, 0, 0, 7, 6, 6 },
      { 4, 3, 5, 1, 0, 2, 7, 6, 8 },
      { 5, 5, 4, 2, 2, 1, 8, 8, 7 },
      { 7, 6, 6, 7, 6, 6, 4, 3, 3 },
      { 7, 6, 8, 7, 6, 8, 4, 3, 5 },
      { 8, 8, 7, 8, 8, 7, 5, 5, 4 },
    };
  for ( j = 0; j < 5; j++ )
    i += o[y / p9[j] % 9][x / p9[j] % 9] * p9[j];
  return ( i );
}
